【leetcode】1-两数之和

题目描述
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

思路分析

  1. 暴力法
    遍历每个元素 ,循环嵌套,寻找nums[i]+nums[j]==target的i,j分别输出到新数组中即可。
class Solution {
    static int[] nums;
	static int target;
    public static int[] twoSum(int[] nums, int target) {
        int[] a=new int[2];
		for(int i=0;i<nums.length-1;i++){
			for(int j=i+1;j<nums.length;j++){
				if(nums[i]+nums[j]==target){
					a[0]=i;
					a[1]=j;
					break;
				}
			}
		}
		return a;
    }
    public static void main(String[] args) {
		int[] nums={11,15,2,7};
		int[] res=twoSum(nums,9);
		System.out.println("["+res[0]+","+res[1]+"]");
	}
}

时间复杂度:O(n^2) 对于每个元素,我们试图通过遍历数组的其余部分来寻找它所对应的目标元素,这将耗费 O(n)的时间。因此时间复杂度为 O(n^2)
空间复杂度:O(1)O(1)。

  1. Hash表
    事实证明,我们可以一次完成。在进行迭代并将元素插入到表中的同时,我们还会回过头来检查表中是否已经存在当前元素所对应的目标元素。如果它存在,那我们已经找到了对应解,并立即将其返回。
class Solution {
    static int[] nums;
    static int target;
    public static int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
        throw new IllegalArgumentException("No two sum solution");
    }
    public static void main(String[] args) {
		int[] nums={11,15,2,7};
		int[] res=twoSum(nums,9);
		System.out.println("["+res[0]+","+res[1]+"]");
	}
}

复杂度分析:
时间复杂度:O(n), 我们只遍历了包含有 n个元素的列表一次。在表中进行的每次查找只花费 O(1)的时间。
空间复杂度:O(n) 所需的额外空间取决于哈希表中存储的元素数量,该表最多需要存储 n个元素。

在这里插入图片描述

发布了37 篇原创文章 · 获赞 22 · 访问量 3万+

猜你喜欢

转载自blog.csdn.net/zkzbhh/article/details/85046135
今日推荐